require "log"
require "math"
require "globals"
require "WorldObject"

Bullet = inheritsFrom(WorldObject)

function Bullet:new(from_fighter, x,y, xVel, yVel, heading)
	local self = self:create()
	self.name = "Bullet"
	self.heading = 0
	self.mass = .01
	self.extra = 10

	self.x,self.y = x, y
	self.xVel = xVel + (math.sin(heading)*500)
	self.yVel = yVel + (math.cos(heading)*500) --Remember Y is always inverted
	self.status = 1
	return self
end

function Bullet.preLoad()
--	global.bulletImage = love.graphics.newImage(global.asteroidImageName)
end

function Bullet:extraDamage(world_object)
	return self.extra
end

function Bullet:draw()
	--Move to top left of the object for drawing
	love.graphics.rotate(self.heading)
	--love.graphics.translate(-self.w/2,-self.h/2) 

	--Draw the bulllet
--	love.graphics.drawq(self.image_map, self.quad, 0, 0)
	love.graphics.setColorMode("replace")
	love.graphics.setColor(150,150,255)
	love.graphics.setPoint(2, "smooth")
	love.graphics.point(0,0)
end

function Bullet:update(dt)
	self.x = self.x + self.xVel*dt
	self.y = self.y + self.yVel*dt
end

function Bullet:receiveCollision(hit_list, world_object)
	if world_object.mass > 0 then
		self.status = 0
	end
end

function Bullet:outOfBounds()
	self.status = 0
end
