-- Input class

Input = {
	name = "input",
	ship = nil,
	missileReady = false
}			--Object definition
Input.__index = Input 
function Input:new(ship)
	local o = {}		--The instanciation of the object
	setmetatable(o, self)
	self.ship = ship or nil
	if self.ship then self.ship.pilot = self end
	log(" Loaded input, attached to: " .. ship.name or "Nothing.")
	return o
end

function Input:attach(ship)
	self.ship = ship
	self.ship.pilot = self
	log(" Attaching input to: " .. ship.name)
end


function Input:gameControlUpdate(dt)
	if love.keyboard.isDown("escape") then love.event.push("q") end

	if love.keyboard.isDown("=") then camera.setScale(1); print("Scale UP!") end
	if love.keyboard.isDown("-") then camera.setScale(.2) end
	--if love.keyboard.isDown("p") then self.ship:explode() end
end

function Input:update(dt)
	if love.keyboard.isDown(" ") then
		self.ship:shoot()
	end
	if love.keyboard.isDown("m") and not self.missileReady then 
		self.ship:readyMissile() 
		self.missileReady = true
	elseif not love.keyboard.isDown("m") and self.missileReady then
		self.ship:launchMissile()
		self.missileReady = false
	end
	if love.keyboard.isDown("e") then
		self.ship:targetClosestThreat()
	end
	-- Engines labeled clockwise FL,FR,RR,RL 1-4. This activates them.
	if love.keyboard.isDown("w") then
		self.ship:burnEngine(4, dt) --RL
		self.ship:burnEngine(3, dt) --RR
	end
	if love.keyboard.isDown("a") then
		self.ship:burnEngine(1, dt) --FL
		self.ship:burnEngine(3, dt) --RR
	end
	if love.keyboard.isDown("s") then
		self.ship:burnEngine(1, dt) --FL
		self.ship:burnEngine(2, dt) --FR
	end
	if love.keyboard.isDown("d") then
		self.ship:burnEngine(2, dt) --FR
		self.ship:burnEngine(4, dt) --RL
	end

end
