require "log"
require "math"
require "globals"
require "WorldObject"

Marker = inheritsFrom(WorldObject)

function Marker:new(x, y, name)
	local self = self:create()
	--self.xVel = 0
	print (self.xVel .. " " .. self.yVel)
	self.w = 10
	self.h = 10
	self.boundingRadius = 1
	self.x,self.y = x, y
	self.name = name or ""		
	self.status = 1
	self.givesCollisions = false

	return self
end

function Marker:getCircles() --for collider
	--Rotation around the center of the object:
	--x' = x cos f - y sin f
	--y' = y cos f + x sin f
	local circle_list = {}

	local temp_circle = {}
	temp_circle.x = self.x
	temp_circle.y = self.y
	temp_circle.r = 20
	circle_list[#circle_list+1] = temp_circle --Add to temp circle listing

	return circle_list
end

function Marker:draw(cam_rotation)
	love.graphics.setColorMode("modulate")
	love.graphics.setColor(255,0,0)
	love.graphics.print(self.name, 10, 10, cam_rotation)
	love.graphics.setColorMode("replace")
	love.graphics.line(-10,0,10,0)
	love.graphics.line(0,-10,0,10)
	love.graphics.circle("line", 0, 0, 8, 10)
end

function Marker:update(dt)
end

function Marker:receiveCollision(hit_list, world_object)
end
