require "WorldObject"

SmokeTrail = inheritsFrom(WorldObject)

function SmokeTrail:new(fromMissile)
	local self = self:create()
	self.fromMissile = fromMissile
	self.name = "Smoke Trail"
	self.system = love.graphics.newParticleSystem( global.smokeTrailImage, 150 )
	
	self.x = fromMissile.x
	self.y = fromMissile.y
	self.system:setBufferSize( 2000 )
	self.system:setEmissionRate( 40 )
	self.system:setLifetime( -1 )
	self.system:setParticleLife( 30 )
	self.system:setColor( 240, 243, 150, 10, 255, 255, 255, 0 )
	self.system:setSize( 1, 4, 1 )
	self.system:setSpeed(0,20)
	self.system:setSpread( math.rad(45) )
	self.system:setGravity( 0, 0 )
	--self.system:setRotation( math.rad(0), math.rad(0) )
	self.system:setSpin( math.rad(2.5), math.rad(3), 1 )
	self.system:setRadialAcceleration( 0 )
	self.system:setTangentialAcceleration(0)
	self.system:start()
	--self.dispersionTimer = 0
	self.boundingRadius = -1 --Always visible
	self.collides = false
	self.status = 1
	return self
end
function SmokeTrail.preLoad()
	global.smokeTrailImage = love.graphics.newImage(global.smokeTrailImageName)
end

function SmokeTrail:update(dt)
	if self.fromMissile.status < 1  or not self.fromMissile.ignited then
		self.system:pause()
		--self.dispersionTimer = self.dispersionTimer + dt
			
	else
		if not self.system:isActive() then self.system:start() end
		self.x = self.fromMissile.x
		self.y = self.fromMissile.y
		
	end
	self.system:update(dt)
end

function SmokeTrail:draw()
	love.graphics.translate(-self.x, self.y)
	self.system:setPosition(self.x, -self.y)
	self.system:setDirection( self.fromMissile.heading + math.pi/2  )
	love.graphics.setColorMode('modulate')
	love.graphics.setBlendMode('alpha')
	love.graphics.draw(self.system, 0, 0)
	love.graphics.setColorMode('replace')
	
end

function SmokeTrail:outOfBounds()
	--self.system:stop()
end
