require "log"
require "World"
require "Input"
require "Camera"
require "Hud"
require "helpers"
require "AI.lua"
require "AIBasic.lua"


function love.load()
	log("Loading...")
	preLoad()
	global.world = World:new()
	camera.set(1024, 768)
		
	local ai1_fighter = World:spawnFighter("AI Fighter")
	global.playerVehicle = World:spawnFighter("Players Fighter")
	
	global.playerInput = Input:new(global.playerVehicle)
	hud.set(global.playerVehicle, global.world)

	local ai1 = AIBasic:new(the_world, ai1_fighter, "AI1")
	
	--global.world:spawnMarker(0, 0, "A")
global.world:spawnMarker(1000, 200, "B")
global.world:spawnMarker(0, 100, "C")



--	ai1:q( {"goToXYFullStop", 0, 100} )
	ai1:q( {"turnToObject", global.playerVehicle} )
	ai1:q( {"turnToHeading", math.pi/2} )
	ai1:q( {"sleep", 2} )
	ai1:q( {"goToXYFullStop", 1000, 200} )
	ai1:q( {"stop"} )
--	ai1:q( {"turnToHeading", 0} )
	
	log("Done setting up.")
	global.gameStart = love.timer.getTime()
end

function love.draw()
	camera.draw(global.world, global.playerVehicle:getX(), global.playerVehicle:getY(), global.playerVehicle:getHeading())
	hud.draw()
end

function love.update(dt)
	if love.timer.getTime() - global.gameStart > 1 then
		global.gameState = 1
	end
	if global.gameState > 0 then	
		if global.playerInput then global.playerInput:gameControlUpdate(dt) end 
		global.world:update(dt)
	end
end

function preLoad()
	Fighter.preLoad()
	World.preLoad()
	Explosion.preLoad()
	ExplosionB.preLoad()
	Missile.preLoad()
	SmokeTrail.preLoad()
	Asteroid.preLoad()
	hud.preLoad()
	log("Preloading done.")
end
